<?
		$rubrique = 3;
		$meta_description = "Les incompatibilits entre le C et le C++";
		$meta_keywords = "Incompatibilits, C, C++, informatique, programmation";
		$titre_page = "Les incompatibilits entre le C et le C++";
		$urlCss = "./article.css";
		$xhtml=true;
        
			$Auteur="Nicolas Joseph";
			$Licence="2";
			$Annee="2006";
		
		$dateBrute['date'] = '24 Juillet 2005';
		$dateBrute['miseajour'] = '';
		
				$topicType = 'Whitepaper';
			include("$DOCUMENT_ROOT/template/entete.php");
		?>
		  <div style="text-align:center;">
		  <table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
			<tr>
			  <td align="center" style="text-align:left">
	<br/><h1>Les incompatibilits entre le C et le C++</h1><p class="dateArticle">
		Date de publication : 24 Juillet 2005</p><p style="text-align: center;">
        Par
        <a class="auteur" href="http://www.developpez.net/forums/member.php?u=41072">Nicolas Joseph</a> <a class="homepage" href="http://nicolasj.developpez.com"> (home)</a><br/>&nbsp;</p><div class="synopsis">
		Le C et le C++ sont deux langages proches au niveau de leur syntaxe et de leur grammaire (si l'on met de ct les proprits objet du C++), cependant il existe un certain nombre d'incompatibilits qui fait qu'un programme crit en C peut ne pas compiler avec un compilateur C++.
		La plupart des incompatibilits listes ci-dessous, en particulier celles valables pour le C90, peuvent tre vites avec un compilateur bien configur et de bonnes habitudes de programmation.
	</div>
		<br /><a class="summaryIndent0" href="#LI">Entre le C (90 et 99) et le C++</a>
			
			<br /><a class="summaryIndent1" href="#LI-A">Les pointeurs de type void</a>
				
				

				

				

				

			
			<br /><a class="summaryIndent1" href="#LI-B">L'intruction goto</a>
				
				

				

				

			
			<br /><a class="summaryIndent1" href="#LI-C">Le type d'un caractre</a>
				
				

				

				
			
			<br /><a class="summaryIndent1" href="#LI-D">Initialisation de tableaux de caractres</a>
				
				

				
				

			
			<br /><a class="summaryIndent1" href="#LI-E">Type de retour d'une fonction</a>
				
				

				
			
			<br /><a class="summaryIndent1" href="#LI-F">Les boolens</a>
				
				

			
			<br /><a class="summaryIndent1" href="#LI-G">Porte de l'oprateur const</a>
				
				


			
			<br /><a class="summaryIndent1" href="#LI-H">Liste de paramtres vide</a>
				
				

				
			
			<br /><a class="summaryIndent1" href="#LI-I">Structure et typedef portant le mme nom</a>
				
				

				
			
			<br /><a class="summaryIndent1" href="#LI-J">Les numrations</a>
				
						

				
			
			<br /><a class="summaryIndent1" href="#LI-K">strchr</a>
				
				

				

				

				
			
			
			<br /><a class="summaryIndent0" href="#LII">Entre le C90 et le C++</a>
				
			<br /><a class="summaryIndent1" href="#LII-A">La dclaration implicite de fonction</a>
				
				
			
			<br /><a class="summaryIndent1" href="#LII-B">Dclaration implicite du type d'une variable</a>
				
				

			
			<br /><a class="summaryIndent1" href="#LII-C">Dclaration de fonction style K&amp;R</a>
				
				

				
			
		
		<br /><a class="summaryIndent0" href="#LIII">Entre le C99 et le C++</a>
			
			<br /><a class="summaryIndent1" href="#LIII-A">Passage de tableau comme paramtre d'une fonction</a>
				
				

				

				


			
			<br /><a class="summaryIndent1" href="#LIII-B">Initialisation des membres d'une structure</a>
				
				

				

				

			
		
		<br /><a class="summaryIndent0" href="#LIV">Remerciements</a>
			
			

		
	<br/><br/>
		<br /><h1 class="TitreSection0" id="LI">Entre le C (90 et 99) et le C++</h1>
			
			<br /><h2 class="TitreSection1" id="LI-A">Les pointeurs de type void</h2>
				
				<div class="paragraph">
					Un pointeur de type <b>void</b> est un pointeur gnrique. En C, il est possible de raliser une conversion implicite d'un type donn vers le type <b>void</b> et inversement :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">void</span> *p_void;
<span class="c_type">int</span> *p_int;
...
p_void = p_int;
p_int = p_void;</span></pre></td></tr></table></div>
				<div class="paragraph">
					Compiler ce code avec un compilateur C++, provoque l'erreur suivante :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="other_code">Invalid conversion from `void*' to `int*'</span></pre></td></tr></table></div>
				<div class="paragraph">
					Par consquent, la seconde conversion (d'un pointeur gnrique vers un pointeur d'un type donn) n'est pas possible implicitement en C++, il faut le faire de manire explicite grce  l'oprateur de cast :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">void</span> *p_void;
<span class="c_type">int</span> *p_int;
...
p_void = p_int;
p_int = (<span class="c_type">int</span> *)p_void;</span></pre></td></tr></table></div>
				<table class="tableau" style="width: 98%; text-align: left; border:0;"><tr><td style="width: 40px; vertical-align: top;" class="colonne"><img src="http://www.developpez.be/images/kitinfo.gif" alt="info"/></td><td class="colonne">
					L'oprateur de cast utilis dans cet exemple est un oprateur du C autoris en C++ bien qu'obsolte. Pour un code C++ pur, on prfrera le code suivant :
				<br/></td></tr></table>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="cpp_code"><span class="cpp_keyword"><span class="cpp_type">void</span></span> *p_void;
<span class="cpp_keyword"><span class="cpp_type">int</span></span> *p_int;
...
p_void = p_int;
p_int = <span class="cpp_keyword">static_cast</span>&lt;<span class="cpp_keyword"><span class="cpp_type">int</span></span> *&gt;(p_void);</span></pre></td></tr></table></div>
			
			<br /><h2 class="TitreSection1" id="LI-B">L'intruction goto</h2>
				
				<div class="paragraph">
					L'instruction <b>goto</b> permet de sauter  une tiquette donne. Pour exemple, voici un code qui compile parfaitement en C :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code">   <span class="c_type">int</span> i = 2;
<span class="c_keyword">goto</span> start;
   <span class="c_type">int</span> v = 5;
   printf (<span class="c_ch">"%d\n"</span>, v);
start:
   printf (<span class="c_ch">"%d\n"</span>, i);</span></pre></td></tr></table></div>
				<div class="paragraph">
					Par contre si vous essayez de compiler ceci   l'aide d'un compilateur C++, vous obtiendrez l'erreur suivante :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="other_code">Crosses initialization of `int v'</span></pre></td></tr></table></div>
				<div class="paragraph">
					Car en C++, l'instruction <b>goto</b> ne peut pas tre utilise pour sauter une dclaration comportant une initialisation sauf si le bloc qui contient cette dclaration est entirement saut :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code">   <span class="c_type">int</span> i = 2;
<span class="c_keyword">goto</span> start;
   <span class="c_keyword">if</span> (i == 2)
   {
      <span class="c_type">int</span> v = 5;
      printf (<span class="c_ch">"%d\n"</span>, v);
   }
start:
   printf (<span class="c_ch">"%d\n"</span>, i);</span></pre></td></tr></table></div>
			
			<br /><h2 class="TitreSection1" id="LI-C">Le type d'un caractre</h2>
				
				<div class="paragraph">
					Les types utiliss pour reprsenter les caractres ne sont pas les mmes en C et en C++. Pour le premier, il s'agit d'un entier (<b>int</b>) alors que pour le second ce sont des <b>char</b>. Cela a son importance au niveau de la surchage des fonctions (mcanisme spcifique au C++) puisque dans cet exemple :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">void</span> printchar (<span class="c_type">int</span> c)
{
   printf (<span class="c_ch">"%c\n"</span>, c);
}

<span class="c_type">void</span> printchar (<span class="c_type">char</span> c)
{
   printf (<span class="c_ch">"%c\n"</span>, c);
}</span></pre></td></tr></table></div>
				<div class="paragraph">
					L'instruction :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code">printchar ('a');</span></pre></td></tr></table></div>
				<div class="paragraph">
					Appelera la seconde fonction en C++.
				</div><br/>
			
			<br /><h2 class="TitreSection1" id="LI-D">Initialisation de tableaux de caractres</h2>
				
				<div class="paragraph">
					En C, il est possible d'initialiser un tableau de caractres avec une chane de caractres de mme longueur (sans compter le caractre de fin de chaine \0) :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">char</span> tab[10] = <span class="c_ch">"Developpez"</span>;</span></pre></td></tr></table></div>
				<table class="tableau" style="width: 98%; text-align: left; border:0;"><tr><td style="width: 40px; vertical-align: top;" class="colonne"><img src="http://www.developpez.be/images/kitwarning.gif" alt="warning"/></td><td class="colonne">
					Attention, dans ce cas, on obtient un tableau de caractres et non une chane de caractres puisque le caractre \0 n'est pas prsent.
				<br/></td></tr></table>
				<div class="paragraph">
					Cette mme instruction donnera en C++ :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code">Initializer-string <span class="c_keyword">for</span> array of chars is too <span class="c_type">long</span></span></pre></td></tr></table></div>
			
			<br /><h2 class="TitreSection1" id="LI-E">Type de retour d'une fonction</h2>
				
				<div class="paragraph">
					En C, si vous omettez le type de retour d'une fonction lors de sa dclaration, le compilateur considre que la fonction retourne un <b>int</b> mais en C++ cela n'est pas permis :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code">ISO C++ forbids declaration of `function' with no type</span></pre></td></tr></table></div>
				<table class="tableau" style="width: 98%; text-align: left; border:0;"><tr><td style="width: 40px; vertical-align: top;" class="colonne"><img src="http://www.developpez.be/images/kitinfo.gif" alt="info"/></td><td class="colonne">
					Un compilateur C bien paramtr vous signalera cet oubli par un warning.
				<br/></td></tr></table>
			
			<br /><h2 class="TitreSection1" id="LI-F">Les boolens</h2>
				
				<div class="paragraph">
					Le type boolen est prsent en C99 et en C++ cependant en C, si vous n'incluez pas le fichier <i>stdbool.h</i> il est tout  fait possible de redfinir les termes <b>bool</b>, <b>false</b> et <b>true</b>. Par contre en C++ ceci n'est pas permis :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code">Redeclaration of C++ built-in type `<span class="c_type">bool</span>'</span></pre></td></tr></table></div>
			
			<br /><h2 class="TitreSection1" id="LI-G">Porte de l'oprateur const</h2>
				
				<div class="paragraph">
					En C, la classe d'une variable dclare constante est, par dfaut, externe (<b>extern</b>) alors qu'en C++, elle est interne (<b>static</b>).
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="titre_code">En C :</td></tr><tr><td class="code"><pre><span class="c_code"><span class="c_keyword">const</span> <span class="c_type">int</span> i = 1;
<span class="c_comment">/* signifie :
extern const int i = 1; */</span></span></pre></td></tr></table></div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="titre_code">En C++ :</td></tr><tr><td class="code"><pre><span class="cpp_code"><span class="cpp_keyword">const</span> <span class="cpp_keyword"><span class="cpp_type">int</span></span> i = 1;
<span class="cpp_comment">/* signifie :
static const int i = 1; */</span></span></pre></td></tr></table></div>
			
			<br /><h2 class="TitreSection1" id="LI-H">Liste de paramtres vide</h2>
				
				<div class="paragraph">
					Si, lors de la dclaration d'une fonction, la liste des paramtres n'est pas mentionne, un compilateur C n'effectura pas de vrification. Ainsi le code suivant est correct :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">void</span> foo() {}

<span class="c_type">int</span> main (<span class="c_type">void</span>)
{
  foo ();
  foo (0);
  foo (1, 2);

  <span class="c_keyword">return</span> (0);
}</span></pre></td></tr></table></div>
				<div class="paragraph">
					Par contre en C++ une liste de paramtres vide est considre comme valant <b>void</b>.
				</div><br/>
			
			<br /><h2 class="TitreSection1" id="LI-I">Structure et typedef portant le mme nom</h2>
				
				<div class="paragraph">
					En C, la prsence du mot <b>struct</b>, <b>enum</b> ou <b>union</b> permet de diffrencier un <b>typedef</b> des types plus complexes (structure, numration ou union) qui portent le mme nom :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_keyword">typedef</span> <span class="c_type">int</span> var;
<span class="c_keyword">struct</span> var { ... }; <span class="c_comment">/* enum ou union revient au mme */</span>

<span class="c_type">int</span> main (<span class="c_type">void</span>) 
{
  var var1;
  <span class="c_keyword">struct</span> var var2;
  ...
  <span class="c_keyword">return</span> (0);
}</span></pre></td></tr></table></div>
				<div class="paragraph">
					Ceci ne pose aucun problme en C, par contre en C++, il y a redfinition.
				</div><br/>
			
			<br /><h2 class="TitreSection1" id="LI-J">Les numrations</h2>
				
				<div class="paragraph">
					En C, une constante numre est en fait un entier sign (<b>signed int</b>) par consquent ceci ne pose pas de problme :
				</div>		
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code">enum etat { TRAVAIL, MANGE, DORT };

<span class="c_type">int</span> v1 = TRAVAIL;
enum etat v2 = 1;</span></pre></td></tr></table></div>
				<div class="paragraph">
					En C++, la conversion implicite entre une numration et un entier n'est pas possible, il faut utiliser l'oprateur de cast.
				</div><br/>
			
			<br /><h2 class="TitreSection1" id="LI-K">strchr</h2>
				
				<div class="paragraph">
					En C, la fonction <b>strchr</b> a le prototype suivant :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">char</span>* strchr (<span class="c_keyword">const</span> <span class="c_type">char</span>* cs, <span class="c_type">int</span> c);</span></pre></td></tr></table></div>
				<div class="paragraph">
					Le C++ propose deux prototypes pour la fonction <b>strchr</b> dans cstring :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">char</span> *strchr (<span class="c_type">char</span> *cs, <span class="c_type">int</span> c);
<span class="c_keyword">const</span> <span class="c_type">char</span> *strchr (<span class="c_keyword">const</span> <span class="c_type">char</span> *cs, <span class="c_type">int</span> c);</span></pre></td></tr></table></div>
				<div class="paragraph">
					Donc le code qui suit est valide en C avec l'en-tte string.h mais invalide en C++ si cstring est incluse :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_keyword">const</span> <span class="c_type">char</span> *cs = <span class="c_ch">"Developpez"</span>;
<span class="c_type">char</span> *p;
p = strchr (cs, 'v');</span></pre></td></tr></table></div>
				<div class="paragraph">
					En effet, puisque <i>cs</i> est constant, c'est la premire fonction <b>strchr</b> qui est appele, or elle retourne une chane constante contrairement  son homologue en C donc pour que le code soit valide, il faut que <i>p</i> soit dclar comme tant constant.
				</div><br/>
			
			
			<br /><h1 class="TitreSection0" id="LII">Entre le C90 et le C++</h1>
				
			<br /><h2 class="TitreSection1" id="LII-A">La dclaration implicite de fonction</h2>
				
				<div class="paragraph">
					En C, si une fonction n'est pas explicitement dclare avant sa premire utilisation, le compilateur considre qu'il s'agit d'une fonction externe (<b>extern</b>) retournant un entier (<b>int</b>) alors que la dclaration est obligatoire en C99 comme en C++.
				</div><br/>
			
			<br /><h2 class="TitreSection1" id="LII-B">Dclaration implicite du type d'une variable</h2>
				
				<div class="paragraph">
					En C, il est possible d'omettre le type de la variable lors de son initialisation. Par dfaut la variable est considre comme tant un <b>int</b>. Un compilateur C++ vous rpondra poliment :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code">ISO C++ forbids declaration of `i' with no type</span></pre></td></tr></table></div>
			
			<br /><h2 class="TitreSection1" id="LII-C">Dclaration de fonction style K&amp;R</h2>
				
				<div class="paragraph">
					Dans des sources ayant un certain ge, on peut trouver ce genre de dclaration :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">int</span> main (argc, argv)
          <span class="c_type">int</span> argc; <span class="c_type">char</span> **argv;
{
   <span class="c_keyword">return</span> (0);
}</span></pre></td></tr></table></div>
				<div class="paragraph">
					C'est une criture dcrite par Kernighan et Ritchie (d'o l'abrviation K&amp;R) tolre uniquement en C90.
				</div><br/>
			
		
		<br /><h1 class="TitreSection0" id="LIII">Entre le C99 et le C++</h1>
			
			<br /><h2 class="TitreSection1" id="LIII-A">Passage de tableau comme paramtre d'une fonction</h2>
				
				<div class="paragraph">
					En C, il est possible de dclarer un pointeur constant sur un <b>int</b> de cette faon :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">int</span> *<span class="c_keyword">const</span> str;</span></pre></td></tr></table></div>
				<div class="paragraph">
					Le C99 apporte une nouvelle manire de le faire (uniquement dans une liste de paramtres d'une fonction) incompatible avec le C++ :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">void</span> foo (<span class="c_type">int</span> str[<span class="c_keyword">const</span>]);</span></pre></td></tr></table></div>
				<div class="paragraph">
					Sera accompagn des erreurs suivantes :
				</div>

<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code">Expected primary-expression before <span class="c_ch">"<span class="c_keyword">const</span>"</span> 
Expected `]' before <span class="c_ch">"<span class="c_keyword">const</span>"</span> 
Expected `,' or `...' before <span class="c_ch">"<span class="c_keyword">const</span>"</span></span></pre></td></tr></table></div>
			
			<br /><h2 class="TitreSection1" id="LIII-B">Initialisation des membres d'une structure</h2>
				
				<div class="paragraph">
					Le C99, permet d'omettre le nom de la variable lors de l'initialisation des membres d'une structure :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_keyword">struct</span> client
{
  <span class="c_type">char</span> nom[21];
  <span class="c_type">int</span> cp;
  <span class="c_type">char</span> pays[21];
};
...
<span class="c_keyword">struct</span> client client1 =
{
  .nom = <span class="c_ch">"Paul"</span>,
  .cp = 75,
  .pays = <span class="c_ch">"France"</span>
};</span></pre></td></tr></table></div>
				<div class="paragraph">
					Ce qui en C++ n'est pas autoris :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code">Expected primary-expression before '.' token</span></pre></td></tr></table></div>
				<div class="paragraph">
					Il faut utiliser le code suivant :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_keyword">struct</span> client client1 = 
{ 
  <span class="c_ch">"Paul"</span>, 
  75, 
  <span class="c_ch">"France"</span> 
};</span></pre></td></tr></table></div>
			
		
		<br /><h1 class="TitreSection0" id="LIV">Remerciements</h1>
			
			<div class="paragraph">
				Merci  Anomaly et  Loulou24 pour leurs conseils sur le contenu de cet article<br />
				Merci  2Eurocents et  Beuss pour leurs contributions respectives  la relecture de cet article
			</div><br/>

		
	<br/><hr/><p style="text-align:center;"><a href="http://validator.w3.org/check?uri=referer"><img src="http://www.w3.org/Icons/valid-xhtml11" alt="Valid XHTML 1.1!" height="31" width="88"/></a><a href="http://jigsaw.w3.org/css-validator/check/referer"><img style="border:0;width:88px;height:31px" src="http://jigsaw.w3.org/css-validator/images/vcss" alt="Valid CSS!"/></a></p><div id="xiti-logo" style="text-align:center;">
<a href="http://www.xiti.com/xiti.asp?s=205564" title="Mesurez votre audience">
<script type="text/javascript">
<!--
Xt_param = 's=205564&p=articles/incompatibilites';
Xt_r = document.referrer;
Xt_h = new Date();
Xt_i = '<img width="39" height="25" border="0" ';
Xt_i += 'src="http://logv28.xiti.com/hit.xiti?'+Xt_param;
Xt_i += '&hl='+Xt_h.getHours()+'x'+Xt_h.getMinutes()+'x'+Xt_h.getSeconds();
if(parseFloat(navigator.appVersion)>=4)
{Xt_s=screen;Xt_i+='&r='+Xt_s.width+'x'+Xt_s.height+'x'+Xt_s.pixelDepth+'x'+Xt_s.colorDepth;}
document.write(Xt_i+'&ref='+Xt_r.replace(/[<>"]/g, '').replace(/&/g, '$')+'" title="Analyse d\'audience">');
//-->
</script>
<object>
<noscript>
<div id="xiti-logo-noscript-205564">
Mesure d'audience ROI frequentation par <img width="39" height="25" src="http://logv28.xiti.com/hit.xiti?s=205564" alt="Analyse d'audience" />
</div>
</noscript>
</object>
</a></div>
	  </td>
		</tr>
		   </table></div>
<?
	include("$DOCUMENT_ROOT/template/pied.php");?>